gtkmm: Gtk::NumericSorter< T > Class Template Reference

gtkmm 4.13.3

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Gtk::NumericSorter< T > Class Template Reference
ListView Classes

Sort by comparing numbers. More...

`#include <gtkmm/numericsorter.h>`

Inheritance diagram for Gtk::NumericSorter< T >:
[legend]

## Public Member Functions
Glib::RefPtr< Expression< T > > | get_expression ()
| Gets the expression that is evaluated to obtain numbers from items. More...
Glib::RefPtr< const Expression< T > > | get_expression () const
| Gets the expression that is evaluated to obtain numbers from items. More...
void | set_expression (const Glib::RefPtr< Expression< T > > & expression)
| Sets the expression that is evaluated to obtain numbers from items. More...
Glib::PropertyProxy< Glib::RefPtr< Expression< T > > > | property_expression ()
| The expression to evalute on items to get a number to compare with. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Expression< T > > > | property_expression () const
| The expression to evalute on items to get a number to compare with. More...
Public Member Functions inherited from Gtk::NumericSorterBase
| NumericSorterBase (NumericSorterBase && src) noexcept
NumericSorterBase & | operator= (NumericSorterBase && src) noexcept
| ~NumericSorterBase () noexcept override
GtkNumericSorter * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkNumericSorter * | gobj () const
| Provides access to the underlying C GObject. More...
GtkNumericSorter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
SortType | get_sort_order () const
| Gets whether this sorter will sort smaller numbers first. More...
void | set_sort_order (SortType sort_order)
| Sets whether to sort smaller numbers before larger ones. More...
Glib::PropertyProxy< SortType > | property_sort_order ()
| Whether the sorter will sort smaller numbers first. More...
Glib::PropertyProxy_ReadOnly< SortType > | property_sort_order () const
| Whether the sorter will sort smaller numbers first. More...
Public Member Functions inherited from Gtk::Sorter
| Sorter (Sorter && src) noexcept
Sorter & | operator= (Sorter && src) noexcept
| ~Sorter () noexcept override
GtkSorter * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkSorter * | gobj () const
| Provides access to the underlying C GObject. More...
GtkSorter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Ordering | compare (gpointer item1, gpointer item2)
| Compares two given items according to the sort order implemented by the sorter. More...
Order | get_order () const
| Gets the order that self conforms to. More...
void | changed (Change change)
| Notifies all users of the sorter that it has changed. More...
Glib::SignalProxy< void(Change)> | signal_changed ()
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static Glib::RefPtr< NumericSorter > | create (const Glib::RefPtr< Expression< T > > & expression)
Static Public Member Functions inherited from Gtk::NumericSorterBase
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Sorter
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| NumericSorter (const Glib::RefPtr< Expression< T > > & expression)
Protected Member Functions inherited from Gtk::NumericSorterBase
| NumericSorterBase (const Glib::RefPtr< ExpressionBase > & expression)
Protected Member Functions inherited from Gtk::Sorter
| Sorter ()
virtual Ordering | compare_vfunc (gpointer item1, gpointer item2)
virtual Order | get_order_vfunc ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Additional Inherited Members
Public Types inherited from Gtk::Sorter
enum class | Order { Order::PARTIAL , Order::NONE , Order::TOTAL }
| Describes the type of order that a `Gtk::Sorter` may produce. More...
enum class | Change { Change::DIFFERENT , Change::INVERTED , Change::LESS_STRICT , Change::MORE_STRICT }
| Describes changes in a sorter in more detail and allows users to optimize resorting. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Related Functions inherited from Gtk::NumericSorterBase
Glib::RefPtr< Gtk::NumericSorterBase > | wrap (GtkNumericSorter * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Sorter
Glib::RefPtr< Gtk::Sorter > | wrap (GtkSorter * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

template<class T>
class Gtk::NumericSorter< T >

Sort by comparing numbers.

Gtk::NumericSorter is a Gtk::Sorter that compares numbers.

To obtain the numbers to compare, this sorter evaluates a Gtk::Expression.

See also
  Gtk::Expression

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ NumericSorter()

template <class T >

Gtk::NumericSorter< T >::NumericSorter | ( | const Glib::RefPtr< Expression< T > > & | expression | ) |
| protected

## Member Function Documentation

## ◆ create()

template <class T >

static Glib::RefPtr< NumericSorter > Gtk::NumericSorter< T >::create | ( | const Glib::RefPtr< Expression< T > > & | expression | ) |
| static

## ◆ get_expression() [1/2]

template <class T >

Glib::RefPtr< Expression< T > > Gtk::NumericSorter< T >::get_expression | ( |  | ) |

Gets the expression that is evaluated to obtain numbers from items.

Returns
  A Gtk::Expression, or `nullptr`.

## ◆ get_expression() [2/2]

template <class T >

Glib::RefPtr< const Expression< T > > Gtk::NumericSorter< T >::get_expression | ( |  | ) | const

Gets the expression that is evaluated to obtain numbers from items.

Returns
  A Gtk::Expression, or `nullptr`.

## ◆ property_expression() [1/2]

template <class T >

Glib::PropertyProxy< Glib::RefPtr< Expression< T > > > Gtk::NumericSorter< T >::property_expression | ( |  | ) |

The expression to evalute on items to get a number to compare with.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_expression() [2/2]

template <class T >

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Expression< T > > > Gtk::NumericSorter< T >::property_expression | ( |  | ) | const

The expression to evalute on items to get a number to compare with.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_expression()

template <class T >

void Gtk::NumericSorter< T >::set_expression | ( | const Glib::RefPtr< Expression< T > > & | expression | ) |

Sets the expression that is evaluated to obtain numbers from items.

Unless an expression is set on the Gtk::NumericSorter, the sorter will always compare items as invalid.

The expression must have a return type that can be compared numerically, such as int or double.

Parameters

  expression | A Gtk::Expression, or `nullptr`.